import { UX } from '@salesforce/command';
import { Logger } from '@salesforce/core';
import { Failures, FileProperties, FileResponse, Successes } from '@salesforce/source-deploy-retrieve';
export interface ResultFormatterOptions {
    verbose?: boolean;
    quiet?: boolean;
    waitTime?: number;
    concise?: boolean;
    username?: string;
}
export declare function toArray<T>(entryOrArray: T | T[] | undefined): T[];
export declare abstract class ResultFormatter {
    logger: Logger;
    ux: UX;
    options: ResultFormatterOptions;
    constructor(logger: Logger, ux: UX, options?: ResultFormatterOptions);
    isSuccess(): boolean;
    isVerbose(): boolean;
    isQuiet(): boolean;
    isConcise(): boolean;
    protected sortFileResponses(fileResponses: FileResponse[]): void;
    protected sortFileProperties(fileProperties: FileProperties[]): void;
    protected sortTestResults(results?: Failures[] | Successes[]): Failures[] | Successes[];
    protected asRelativePaths(fileResponses: FileResponse[]): void;
    abstract getJson(): any;
    abstract display(): void;
}
